No keyboards shortcuts in QT apps

Bug #1380702 reported by Yassin Philip on 2014-10-13
346
This bug affects 114 people
Affects Status Importance Assigned to Milestone
Canonical System Image
High
Łukasz Zemczak
appmenu-qt5
High
Łukasz Zemczak
sni-qt
New
Undecided
Unassigned
qtbase-opensource-src (Ubuntu)
Undecided
Dmitry Shachnev
Xenial
Undecided
Unassigned
Yakkety
Undecided
Unassigned

Bug Description

Impact
======

This affects all Qt applications on Unity and other desktops which use global menu, either via appmenu-qt5 or via native implementation on Yakkety.

Any shortcut is not working if the corresponding action is attached only to the menubar (i.e. and not also to the toolbar). It can be reproduced with almost any application by removing the toolbar (right-clicking on it and deselecting it).

Test Case
=========

* Open Qt Assistant;
* Press Ctrl+T (this action is not on the toolbar).

Expected: a new tab should be opened. Current result: nothing happens.

In Yakkety the fix should work both with and without appmenu-qt5.

Proposed Fix
============

The proposed fix is a backport of the upstream fix at https://code.qt.io/cgit/qt/qtbase.git/commit/?id=287f548d4c7cc594.

Actually just the qshortcut.cpp part would be sufficient, but the other parts make sure it plays fine together with https://cgit.kde.org/plasma-integration.git/commit/?id=aef74e97e2ed462a.

Regression Potential
====================

The fix is in Zesty for 1½ months now (in upstream even longer), and so far nobody complained. People have verified that the fix works (see comment #63).

Changed in unity:
status: New → Won't Fix
no longer affects: unity
Dirk Hohndel (dirk-3) wrote :

I'm puzzled that this is marked as Won't Fix - the bug is clearly alive and well.
For example when running Subsurface (from our PPA:subsurface/subsurface - the one that sadly is still in the Ubuntu repositories is outdated and broken) you get no working shortcut keys if appmenu-qt5 is installed, but uninstalling appmenu-qt5 fixes this and Subsurface shortcuts work as expected.
This has been tested with a fully updated 15.04 yesterday.

Timo Jyrinki (timo-jyrinki) wrote :

Marco just meant it's not a bug inside unity code. The bug is still targetted towards appmenu-qt5 and sni-qt.

Launchpad Janitor (janitor) wrote :

Status changed to 'Confirmed' because the bug affects multiple users.

Changed in ubuntu:
status: New → Confirmed
Changed in appmenu-qt5:
status: New → Confirmed
Changed in canonical-devices-system-image:
assignee: nobody → Pat McGowan (pat-mcgowan)
importance: Undecided → High
milestone: none → ww40-2015
status: New → Confirmed
Changed in appmenu-qt5:
assignee: nobody → Timo Jyrinki (timo-jyrinki)
Timo Jyrinki (timo-jyrinki) wrote :

Reassigning, Łukasz has created the appmenu-qt5.

Changed in appmenu-qt5:
assignee: Timo Jyrinki (timo-jyrinki) → Łukasz Zemczak (sil2100)
Łukasz Zemczak (sil2100) wrote :

Taking a look at this now. I reproduced it with multiple Qt5 applications - first step now is to triage which exact component is responsible. appmenu-qt5 doesn't do much by itself, as it's only a QPA platformtheme plugin that takes the window's QMenu's and exports it through DBus. Need to check what Qt does when it actually has a platformtheme loaded and a platformmenu defined - maybe in this case dealing with shortcuts is also left for the theme's implementation? We'll see.

Changed in appmenu-qt5:
status: Confirmed → Triaged
importance: Undecided → High
Changed in appmenu-qt5:
status: Triaged → In Progress
Łukasz Zemczak (sil2100) wrote :

Ok, identified the initial problem here. It's not any recent problem - it's an issue that seems to be with appmenu-qt5 and Qt5 since the very beginning. It's not really a bug in appmenu-qt5, more like a design decision that Qt5 had that I wasn't aware of.

The main problem here is that once we load up the QPA platformtheme and the QMenuBar object is able to create the QPlatformMenuBar instead, what it does is it hides the original QMenuBar (doing w->hide()). In Qt5 a hidden menubar (and probably any other widget/ui object) does not get any events when being hidden. appmenu-qt5 is a simple plugin that doesn't do any of that handling. Actually I'm not even sure if it's easily possible to add shortcut handling to a QPlatformMenuItem - the QAction wrapper around platformtheme plugins. I'll look into that in detail tomorrow, maybe we might be able to resolve this somehow without patches upstream.

Scott Howard (showard314) wrote :

Hi, just marked Bug #1386111 as a duplicate of this. As a workaround they found that removing appmenu-qt5 restored the missing functionality.

Łukasz Zemczak (sil2100) wrote :

Investigating this bug in-between release tasks. I'm starting to think we might not be able to fix this without modifying Qt5 in the end. Looking at Qt5 QShortcut code, there even is a very specific 'hack' to enable shortcuts for MacOSX systems that also have a global menu. The shortcut map is being passed a contextMatcher, and one of the first checks in the context matcher is the check if the owning widget is visible or not. In the case of the usage of platform menu bars, as mentioned in comment #6, the source QMenuBar is hidden. In other words, at that place the shortcut is basically not considered when the widget is not visible. So how does OSX still have shortcuts working? By an ugly ifdef in the Qt code:

    bool visible = w->isVisible();
#ifdef Q_OS_MAC
    if (!qApp->testAttribute(Qt::AA_DontUseNativeMenuBar) && qobject_cast<QMenuBar *>(w))
        visible = true;
#endif

    if (!visible || !w->isEnabled())
        return false;

So basically OSX is a 'special case' here. I hate ifdefs... this should really be some configurable option, or even better - some option you can define in the QPlatformTheme or QPlatformMenu* objects.

no longer affects: ubuntu
Changed in qtbase-opensource-src (Ubuntu):
assignee: nobody → Łukasz Zemczak (sil2100)
Launchpad Janitor (janitor) wrote :

Status changed to 'Confirmed' because the bug affects multiple users.

Changed in qtbase-opensource-src (Ubuntu):
status: New → Confirmed
Łukasz Zemczak (sil2100) wrote :

Still working on this. My first solution didn't work in 100% - it's high on my priority list. I hope to have it working in a few days.

Changed in qtbase-opensource-src (Ubuntu):
status: Confirmed → In Progress
Changed in canonical-devices-system-image:
status: Confirmed → In Progress
Changed in canonical-devices-system-image:
milestone: ww40-2015 → ww46-2015
Changed in canonical-devices-system-image:
assignee: Pat McGowan (pat-mcgowan) → Zoltan Balogh (bzoltan)
Łukasz Zemczak (sil2100) wrote :

So the current issue I am facing is: for yet unknown reasons it seems that the shortcuts are still not triggered because the shortcut system ignores all shortcuts because it sees them as not attached to any widgets. Which is strange, as in all moments of the application the action seems to be attached to the right widget - I checked that. Could it be that when the shortcut is triggered, the actions are modified somehow and detached from invisible menus..?

Changed in canonical-devices-system-image:
assignee: Zoltan Balogh (bzoltan) → Łukasz Zemczak (sil2100)
Changed in canonical-devices-system-image:
milestone: ww46-2015 → ww02-2016
Changed in canonical-devices-system-image:
milestone: ww02-2016 → ww08-2016
Changed in canonical-devices-system-image:
milestone: ww08-2016 → backlog
Benjamin Sperisen (lasindi) wrote :

I'm experiencing this bug on Ubuntu 15.10.

eXcuvator (excuvator) wrote :

I'm experiencing this bug on Ubuntu 16.04 with texmaker. Hotkeys do not work when this package is installed. After removing the package, they do work. (Wondering what package to fall back on - this clearly used to work and texmaker now looks like a naked chicken)

Christophe (touil1976) wrote :

eXcuvator, there is another workaround. Reinstall app-menu-qt5, and launch texmaker (for example in a terminal) with :
env UBUNTU_MENUPROXY= texmaker
This will disable the global menu in texmaker, the menu being now within the window. The keyboard shortcuts work perfectly this way.

Gavin Bisesi (daenyth+ubuntu) wrote :

My users for Cockatrice have reported this as well and it's not entirely clear that having appmenu removed fixes it. https://github.com/Cockatrice/Cockatrice/issues/476

erio (eri0) wrote :

Just reporting that this bug also affects PyQt5, on Ubuntu 14.04 and 16.04.

erio (eri0) wrote :

Reporting that this bug doesn't affect pyqt5 on Lubuntu 16.04. Everything works there - I thought it was the same package.

Robert Orzanna (orschiro) wrote :

Dear Erico_pt,

How is it possible that Lubuntu 16.04 is not affected but Ubuntu 16.04 is?

Thankfully,

~Robert

erio (eri0) wrote :

Dear Robert,

Good question.

I discovered that the PyQt5 I had in the Lubuntu machine was from pip3. So it had the shortcuts working, but had the problem with overlay scrollbars that make the window crash and throw the error here https://bugs.launchpad.net/ubuntu/+source/qt4-x11/+bug/805303 .

Uninstalled and installed the python3-pyqt5 package and had the non-working shortcuts back.

Sorry for mixing things and now things makes more sense!

It may be related to this bug, the menubar in QT programs (Chrome and IntelliJ software are affected too) doesn't show the shortcut next to the menu item.
This make imposible to learn a program's shortcuts since they are not visible.

Is there any progress here? When the bug is planned to be fixed?

tags: added: a11y unity8-desktop
Edwin Khoo (edwinksl) wrote :

This bug also affects VLC as detailed in http://askubuntu.com/questions/742127/ctrl-shortcuts-not-working-in-vlc, which also offers a workaround until the bug is fixed.

Marco B. (boro3k) wrote :

Experiencing this issue with TeXstudio on Ubuntu 16.04. The workaround mentioned in #14 appears to work while we wait for a fix. Thank you all for working on this.

Nitin Gupta (nitingupta910) wrote :

Using Ubuntu 16.04 and no keyboard shortcuts visible is Visual Studio Code which is I think based on Chrome. Though shortcuts are not visible alongside menu text, they do trigger correct action when invoked. Still, having them visible alongside menu text would be useful.

Daniel Oehry (daniel-oehry) wrote :

The Problem persists in Ubuntu 16.10. The workaround (removing appmenu-qt5) does not help anymore.

Robert Orzanna (orschiro) wrote :

I can confirm that there is no workaround available anymore for 16.10.

Can you please address this urgent problem?

Not having keyboard shortcuts in Qt5 applications is quite severe.

Albert Astals Cid (aacid) wrote :

It works fine for me.

Which desktop are you using? Which app doesn't have shortcuts working? What's the exact list of all your packages installed?

Dmitry Shachnev (mitya57) wrote :

Albert: there are no shortcuts when a global menu is used (i.e. Unity or the brand new Plasma global menu). There *are* shortcuts for actions exposed on a toolbar (or attached to any other widget), so remove the toolbars before testing.

I have just written a patch for this: https://codereview.qt-project.org/175494. Once it's accepted upstream, I will cherry-pick it to our packaging. Testing or review appreciated!

Changed in qtbase-opensource-src (Ubuntu):
assignee: Łukasz Zemczak (sil2100) → Dmitry Shachnev (mitya57)
Albert Astals Cid (aacid) wrote :

Using konsole, no toolbar, press Ctrl+Shift+N and i get a new window

Robert Orzanna (orschiro) wrote :

I can share an example with you, if you want.

In Ghostwriter [1] I press Ctrl+o to open a file but the file chooser window is not being shown on Ubuntu 16.10.

[1] https://github.com/wereturtle/ghostwriter

Dmitry Shachnev (mitya57) wrote :

Albert: that's because in Konsole (and other applications using KXmlGui) all actions are attached to the main window.

To be more precise, KXMLGUIClient::beginXMLPlug calls actionCollection()->addAssociatedWidget(w), and addAssociatedWidget attaches all actions in the collection to the passed widget.

Try some pure Qt application (I tested with textedit example from qtbase5-examples, with the removed toolbars).

erio (eri0) wrote :

Open Xenial 16.04 desktop (with Unity) , install pyqt5 using apt (sudo apt install python3-pyqt5). Make a program that has a menu bar, the shortcuts are not shown by the side and they don't work.

Uninstall python3-pyqt5, apt install python3-pip. Use pip3 install pyqt5, pyqt5 will install and there is no menu bar integration, but now shortcuts work.

Erio, so this is a workaround?

On Wed, Nov 2, 2016 at 11:39 AM, erio <email address hidden> wrote:

> Open Xenial 16.04 desktop (with Unity) , install pyqt5 using apt (sudo
> apt install python3-pyqt5). Make a program that has a menu bar, the
> shortcuts are not shown by the side and they don't work.
>
> Uninstall python3-pyqt5, apt install python3-pip. Use pip3 install
> pyqt5, pyqt5 will install and there is no menu bar integration, but now
> shortcuts work.
>
> --
> You received this bug notification because you are subscribed to the bug
> report.
> https://bugs.launchpad.net/bugs/1380702
>
> Title:
> No keyboards shortcuts in QT apps
>
> Status in appmenu-qt5:
> In Progress
> Status in Canonical System Image:
> In Progress
> Status in sni-qt:
> New
> Status in qtbase-opensource-src package in Ubuntu:
> In Progress
>
> Bug description:
> In some apps built using QT4 & 5, menu shortcuts are greyed out and
> inoperant. Only alt and FKeys-based shortcuts work. Others, notably
> ctrl+c for copying, do not.
>
> This is quite serious ; mail me for more details.
>
> To manage notifications about this bug go to:
> https://bugs.launchpad.net/appmenu-qt5/+bug/1380702/+subscriptions
>

Dmitry Shachnev (mitya57) wrote :

For 16.04 the workaround is removing appmenu-qt5. Qt binaries installed from third-party sources will have other problems (i.e. icons not showing in the toolbar).

Robert Orzanna (orschiro) wrote :

Thanks, Dmitry!

And for 16.10?

On Thu, Nov 3, 2016 at 8:13 AM, Dmitry Shachnev <email address hidden> wrote:

> For 16.04 the workaround is removing appmenu-qt5. Qt binaries installed
> from third-party sources will have other problems (i.e. icons not
> showing in the toolbar).
>
> --
> You received this bug notification because you are subscribed to the bug
> report.
> https://bugs.launchpad.net/bugs/1380702
>
> Title:
> No keyboards shortcuts in QT apps
>
> Status in appmenu-qt5:
> In Progress
> Status in Canonical System Image:
> In Progress
> Status in sni-qt:
> New
> Status in qtbase-opensource-src package in Ubuntu:
> In Progress
>
> Bug description:
> In some apps built using QT4 & 5, menu shortcuts are greyed out and
> inoperant. Only alt and FKeys-based shortcuts work. Others, notably
> ctrl+c for copying, do not.
>
> This is quite serious ; mail me for more details.
>
> To manage notifications about this bug go to:
> https://bugs.launchpad.net/appmenu-qt5/+bug/1380702/+subscriptions
>

Dmitry Shachnev (mitya57) wrote :

For 16.10, try running your app in isolated D-Bus environment, i.e. “dbus-run-session -- MyApp”. Or wait for the official fix.

Robert Orzanna (orschiro) wrote :

Thanks, Dmitry!

I tried the following which provides me with working keyboard shortcuts in
the app Ghostwriter but which doesn't integrate the menu into the top bar.
Let me ask:

For 16.10 there is no way to have working keyboard shortcuts AND the menu
being integrated into the top bar?

orschiro@x230:~$ dbus-run-session -- ghostwriter
Activating service name='org.gtk.vfs.Daemon'
Successfully activated service 'org.gtk.vfs.Daemon'
Activating service name='org.gnome.GConf'
Successfully activated service 'org.gnome.GConf'
Activating service name='org.gtk.vfs.UDisks2VolumeMonitor'
Successfully activated service 'org.gtk.vfs.UDisks2VolumeMonitor'
Activating service name='org.gtk.vfs.GPhoto2VolumeMonitor'
Successfully activated service 'org.gtk.vfs.GPhoto2VolumeMonitor'
Activating service name='org.gtk.vfs.GoaVolumeMonitor'
Successfully activated service 'org.gtk.vfs.GoaVolumeMonitor'
Activating service name='org.gtk.vfs.AfcVolumeMonitor'
Successfully activated service 'org.gtk.vfs.AfcVolumeMonitor'
Activating service name='org.gtk.vfs.MTPVolumeMonitor'
Successfully activated service 'org.gtk.vfs.MTPVolumeMonitor'

On Thu, Nov 3, 2016 at 10:16 AM, Dmitry Shachnev <email address hidden> wrote:

> For 16.10, try running your app in isolated D-Bus environment, i.e.
> “dbus-run-session -- MyApp”. Or wait for the official fix.
>
> --
> You received this bug notification because you are subscribed to the bug
> report.
> https://bugs.launchpad.net/bugs/1380702
>
> Title:
> No keyboards shortcuts in QT apps
>
> Status in appmenu-qt5:
> In Progress
> Status in Canonical System Image:
> In Progress
> Status in sni-qt:
> New
> Status in qtbase-opensource-src package in Ubuntu:
> In Progress
>
> Bug description:
> In some apps built using QT4 & 5, menu shortcuts are greyed out and
> inoperant. Only alt and FKeys-based shortcuts work. Others, notably
> ctrl+c for copying, do not.
>
> This is quite serious ; mail me for more details.
>
> To manage notifications about this bug go to:
> https://bugs.launchpad.net/appmenu-qt5/+bug/1380702/+subscriptions
>

Dmitry Shachnev (mitya57) wrote :

Until this bug is fixed, no.

Robert Orzanna (orschiro) wrote :

I see. Thanks for clarifying, Dmitry!

On 11/3/16, Dmitry Shachnev <email address hidden> wrote:
> Until this bug is fixed, no.
>
> --
> You received this bug notification because you are subscribed to the bug
> report.
> https://bugs.launchpad.net/bugs/1380702
>
> Title:
> No keyboards shortcuts in QT apps
>
> Status in appmenu-qt5:
> In Progress
> Status in Canonical System Image:
> In Progress
> Status in sni-qt:
> New
> Status in qtbase-opensource-src package in Ubuntu:
> In Progress
>
> Bug description:
> In some apps built using QT4 & 5, menu shortcuts are greyed out and
> inoperant. Only alt and FKeys-based shortcuts work. Others, notably
> ctrl+c for copying, do not.
>
> This is quite serious ; mail me for more details.
>
> To manage notifications about this bug go to:
> https://bugs.launchpad.net/appmenu-qt5/+bug/1380702/+subscriptions
>

Yonatan Yehezkeally (yoniy0) wrote :

Let me just re-iterate that comment #14 includes another workaround, in my opinion superior to removing the `app-menu-qt5` package altogether. I suspect that it would still works in 16.10.

Robert Orzanna (orschiro) wrote :

Yonatan,

I tried to follow the advice of #14 on Ubuntu 16.10 but look:

orschiro@x230:~$ sudo apt install app-menu-qt5
Reading package lists... Done
Building dependency tree
Reading state information... Done
E: Unable to locate package app-menu-qt5

Yonatan Yehezkeally (yoniy0) wrote :

@RobertOrzanna,

Is that after manually removing it, or does 16.10 come that way?

If the latter, I'd still attempt the workaround (as I think it actually works around what's wrong in the relation between QT5 and Ubuntu's Dash, instead of manually 'crippling' Unity to 'force its hand', as it were).

If the former, I'm afraid I don't know how to restore it.

In any case, have you tried using the workaround with an actual QT5 program, to check for shortcut availability?

Changed in appmenu-qt5 (Ubuntu):
status: New → Invalid
Changed in appmenu-qt5 (Ubuntu Xenial):
status: New → Confirmed
Timo Jyrinki (timo-jyrinki) wrote :

Note that it's 'appmenu-qt5', not 'app-menu-qt5'. In 16.10, appmenu-qt5 is no longer installed by default as its functionality was replaced by better upstream implementation (even if still doesn't fix this particular bug).

For 16.04, a fix in appmenu-qt5 would still be welcome too.

Dmitry Shachnev (mitya57) wrote :

Timo: https://codereview.qt-project.org/175494 should work for 16.04 / appmenu-qt5 too. The second patch (for Alt+letter mnemonics) will not apply to Qt 5.6, but that’s not what this bug is about.

Yonatan Yehezkeally (yoniy0) wrote :

@Dimitry, whether or not `appmenu-qt5` is in use in 16.10, that doesn't tell us if running a QT5 program setting `ENV UBUNTU_MENUPROXY= ` returns the use of keyboard shortcuts. Can you confirm / deny?

Dmitry Shachnev (mitya57) wrote :

Yonathan: that may help if appmenu-qt5 is installed. Then use it as “env UBUNTU_MENUPROXY= QT_QPA_PLATFORMTHEME=appmenu-qt5 myapp”.

George-t (george-t) wrote :

Related issue apparently cause by this one:

https://github.com/keepassxreboot/keepassxc/issues/73

have verified uninstalling appmenu-qt5 dissolves the problem.

@Dmitry - Can you clarify the env setting you're specifying - specifically, should I replace "myapp" with the process name of the application in question? for keepassxc eg:

```UBUNTU_MENUPROXY= QT_QPA_PLATFORMTHEME=appmenu-qt5 keepassxc```

or something else?

Many thanks

Launchpad Janitor (janitor) wrote :

Status changed to 'Confirmed' because the bug affects multiple users.

Changed in qtbase-opensource-src (Ubuntu Xenial):
status: New → Confirmed
Dmitry Shachnev (mitya57) wrote :

> @Dmitry - Can you clarify the env setting you're specifying - specifically, should I replace "myapp" with the process name of the application in question?

Yes, replace myapp with the command line of your application.

David Georg Reichelt (dagere) wrote :

This still happens to me when I use texmaker in Ubuntu 16.10. appmenu-qt5 is not installed and changing

/usr/share/applications/texmaker.desktop

(by inserting Exec=env UBUNTU_MENUPROXY= texmaker %F instead of the original Exec) did not change anything either. Installing appmenu-qt5 is not working, too. Are there any known workarounds?

Anatoli (anatoli) wrote :

This bug also affects tray (appindicator) menu items. With

env UBUNTU_MENUPROXY=''

the shortcuts work, but not the tray menu, also problems with updating the tray icon. With

env QT_QPA_PLATFORMTHEME=''

everything works, but the UI degrades considerably (no Unity look&feel). Same behavior when removing appmenu-qt5 (everything works, degraded UI).

Anatoli (anatoli) wrote :

Please also check bug #1574699, looks like they are all related.

Dmitry Shachnev (mitya57) wrote :

Pushed a fix to our repository, it will be available in the next upload.

https://anonscm.debian.org/cgit/pkg-kde/qt/qtbase.git/commit/?id=eb838b990d5c798e

Changed in qtbase-opensource-src (Ubuntu):
status: In Progress → Fix Committed
Anatoli (anatoli) wrote :

Dmitry, thanks for the fixes! If you update the package in your PPA, I could test it in 16.04.

Robert Orzanna (orschiro) wrote :

Wow great!

Will I receive this update if I enable the 16.10 beta package repository?

-R

On Thu, Jan 26, 2017 at 3:10 AM, Anatoli <email address hidden> wrote:

> Dmitry, thanks for the fixes! If you update the package in your PPA, I
> could test it in 16.04.
>
> --
> You received this bug notification because you are subscribed to the bug
> report.
> https://bugs.launchpad.net/bugs/1380702
>
> Title:
> No keyboards shortcuts in QT apps
>
> Status in appmenu-qt5:
> In Progress
> Status in Canonical System Image:
> In Progress
> Status in sni-qt:
> New
> Status in appmenu-qt5 package in Ubuntu:
> Invalid
> Status in qtbase-opensource-src package in Ubuntu:
> Fix Committed
> Status in appmenu-qt5 source package in Xenial:
> Confirmed
> Status in qtbase-opensource-src source package in Xenial:
> Confirmed
>
> Bug description:
> In some apps built using QT4 & 5, menu shortcuts are greyed out and
> inoperant. Only alt and FKeys-based shortcuts work. Others, notably
> ctrl+c for copying, do not.
>
> This is quite serious ; mail me for more details.
>
> To manage notifications about this bug go to:
> https://bugs.launchpad.net/appmenu-qt5/+bug/1380702/+subscriptions
>

no longer affects: appmenu-qt5 (Ubuntu Xenial)
no longer affects: appmenu-qt5 (Ubuntu)
Dmitry Shachnev (mitya57) wrote :

Robert: not yet. We first need to fix it in the development release, then if the fix works we can backport it to 16.04 and 16.10.

Adding a 16.10 task for the time being.

Robert Orzanna (orschiro) wrote :

I see, thanks!

On Thu, Jan 26, 2017 at 12:02 PM, Dmitry Shachnev <email address hidden> wrote:

> Robert: not yet. We first need to fix it in the development release,
> then if the fix works we can backport it to 16.04 and 16.10.
>
> Adding a 16.10 task for the time being.
>
>
> ** Also affects: qtbase-opensource-src (Ubuntu Yakkety)
> Importance: Undecided
> Status: New
>
> --
> You received this bug notification because you are subscribed to the bug
> report.
> https://bugs.launchpad.net/bugs/1380702
>
> Title:
> No keyboards shortcuts in QT apps
>
> Status in appmenu-qt5:
> In Progress
> Status in Canonical System Image:
> In Progress
> Status in sni-qt:
> New
> Status in qtbase-opensource-src package in Ubuntu:
> Fix Committed
> Status in qtbase-opensource-src source package in Xenial:
> Confirmed
> Status in qtbase-opensource-src source package in Yakkety:
> New
>
> Bug description:
> In some apps built using QT4 & 5, menu shortcuts are greyed out and
> inoperant. Only alt and FKeys-based shortcuts work. Others, notably
> ctrl+c for copying, do not.
>
> This is quite serious ; mail me for more details.
>
> To manage notifications about this bug go to:
> https://bugs.launchpad.net/appmenu-qt5/+bug/1380702/+subscriptions
>

Launchpad Janitor (janitor) wrote :

Status changed to 'Confirmed' because the bug affects multiple users.

Changed in qtbase-opensource-src (Ubuntu Yakkety):
status: New → Confirmed
Timo Jyrinki (timo-jyrinki) wrote :

This is currently brewing in PPA https://launchpad.net/~ci-train-ppa-service/+archive/ubuntu/2360/ and going to go to development release from there in a few days. It's bundled with another fix.

Timo Jyrinki (timo-jyrinki) wrote :

Now in zesty-proposed.

Anatoli (anatoli) wrote :

Could you please also add it to xenial-proposed? There's already one version for a fix of another issue (bug #1574699), maybe they could be merged and tested together?

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package qtbase-opensource-src - 5.7.1+dfsg-2ubuntu3~2

---------------
qtbase-opensource-src (5.7.1+dfsg-2ubuntu3~2) zesty; urgency=medium

  [ Dmitry Shachnev ]
  * Backport upstream change to make shortcuts working with global menu
    on Unity (global_menu_shortcuts.diff, LP: #1380702).

  [ Timo Jyrinki ]
  * debian/patches/Add-support-for-selecting-the-printer-plugin-via-the.patch:
    - Backport from Qt 5.9.

 -- Timo Jyrinki <email address hidden> Mon, 30 Jan 2017 09:02:08 +0000

Changed in qtbase-opensource-src (Ubuntu):
status: Fix Committed → Fix Released

So the fix landed in Zesty some 20 days ago. And I can confirm that it works. I tested two Qt5 programs (VLC and KeePassXC) on LiveCD and shortcuts worked.

What about SRU for Xenial and Yakkety?

Anatoli (anatoli) wrote :

I second this. Please backport the fix to 16.04.

description: updated
description: updated
Dmitry Shachnev (mitya57) wrote :

The 16.04 update is in the SRU queue since March 14th, but for some reason it is still not accepted.

Łukasz Zemczak (sil2100) wrote :

I will look into reviewing the SRU uploads today or tomorrow. Thanks!

Hello Yassin, or anyone else affected,

Accepted qtbase-opensource-src into xenial-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/qtbase-opensource-src/5.5.1+dfsg-16ubuntu7.4 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed.Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested, and change the tag from verification-needed to verification-done. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in qtbase-opensource-src (Ubuntu Xenial):
status: Confirmed → Fix Committed
tags: added: verification-needed
Anatoli (anatoli) wrote :

Could you please clarify which package contains the fix? qtbase-opensource-src is not a lib package, appmenu-qt5 is not available from -proposed (yet?)

Dmitry Shachnev (mitya57) wrote :

Anatoli, you need to update libqt5widgets5 (but it’s better to update all Qt packages, of course).

Anatoli (anatoli) wrote :

Dmitry, thanks for the clarification. Is this this one: libqt5widgets5/xenial-proposed 5.5.1+dfsg-16ubuntu7.4? If it is, it apparently doesn't solve the problem.

Javier Coleto (jcoleto) wrote :

As Anatoli, I also updated the package to libqt5widgets5 xenial-proposed 5.5.1+dfsg-16ubuntu7.4 and it didn't solve the problem.

Dmitry Shachnev (mitya57) wrote :

Marking as verification-failed. For some reason d->nativeMenuBar equals -1 and menuBar::isNativeMenuBar() is returning false, so the patch is not working.

I will prepare a new upload for 16.04 shortly.

tags: added: verification-failed
removed: verification-needed
Dmitry Shachnev (mitya57) wrote :

Can you please test the packages in https://launchpad.net/~ci-train-ppa-service/+archive/ubuntu/2753 and check if these are better?

If yes, I will copy them to -proposed.

Javier Coleto (jcoleto) wrote :

The changes seem to solve the bug, as far as I've seen.

Yonatan Yehezkeally (yoniy0) wrote :

I can also confirm that the bug is fixed (tested with Texmaker; I don't have Qt Assistant).

Dmitry Shachnev (mitya57) wrote :

Thanks for the quick testing! I have copied this to the 16.04 SRU queue now.

Dmitry Shachnev (mitya57) wrote :

The new upload is in proposed now, marking as verification-done per comments 74 and 75.

tags: added: verification-done
removed: verification-failed
Anatoli (anatoli) wrote :

I can also confirm that the latest version fixes the bug on Ubuntu 16.04. Thanks, Dmitry!

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Duplicates of this bug

Other bug subscribers

Remote bug watches

Bug watches keep track of this bug in other bug trackers.